#include "shared.h"
#include "multiReader.h"



void multiReader::printArg(FILE *argFile){
  fprintf(argFile,"%s:\n\n",__FILE__);
  fprintf(argFile,"-nLines=%d\n",nLines);
  fprintf(argFile,"-chunkSize=%d \n",chunkSize);
  fprintf(argFile,"\n");
}
void multiReader::getOptions(argStruct *arguments){
  nLines=1000;
  chunkSize = 10000;
  nLines=angsd::getArg("-nLines",nLines,arguments);
  chunkSize=angsd::getArg("-chunkSize",chunkSize,arguments);
  printArg(arguments->argumentFile);
}


multiReader::multiReader(int type_a,argStruct *arguments) {

  type = type_a;
  if(type>5||type==-1)
    return;
  getOptions(arguments);
  //  fprintf(stderr,"type_a=%d\n",type_a);
  sm=NULL;
  pl=NULL;
  mytglfs=NULL;

  // pg=pg_in;

  switch(type){
  case 0:{
    //    fprintf(stderr,"\t[%s] assuming soapfile\n",__FUNCTION__);
    sm = new soapMaster (arguments);
    break;
  }
  case 1:{
    //fprintf(stderr,"\t[%s] assuming glfv3 files \n",__FUNCTION__);
    //    pl = new pileups (faifile,lStart,lStop,filenames,type);
    pl = new pileups (arguments);
    break;
  }
  case 2:{
    //fprintf(stderr,"\t[%s] assuming glfv3 files \n",__FUNCTION__);
    //    pl = new pileups (faifile,lStart,lStop,filenames,type);
    pl = new pileups (arguments);
    break;
  }
  case 3:{
    //fprintf(stderr,"\t[%s] assuming tglf\n",__FUNCTION__);
    mytglfs = new tglfs;
    mytglfs->init(arguments);
    break;
  }
  case 4:{
    //  fprintf(stderr,"\t[%s] assuming simulation files (single pop)\n",__FUNCTION__);
    mysims = new reader_sim;
    mysims->init(arguments);
    break;
  }
  case 5:{
    //fprintf(stderr,"\t[%s] assuming beagle gprobs input \n",__FUNCTION__);
    bglObj = new beagle_reader;
    bglObj->init(arguments);
    break;
  }
    
  default:{
    //    fprintf(stderr,"\t[%s] assuming what ?\n",__FUNCTION__);
    //pl = new pileups (faifile,lStart,lStop,filenames,type);
    break;
  }
  }
  
}

multiReader::~multiReader(){
 
  switch(type){
  case 0:{
    delete sm;
    break;
  }
  case 3:{
    mytglfs->close();
    delete mytglfs;
    break;
  }
  case 4:{
    mysims->close();
    delete mysims;
    break;
  }    
  case 5:{
    delete bglObj;
      //    delete mysims;
    break;
  }    
  default:{
    delete pl;
    break;
  }
  }

}
funkyPars *multiReader::fetch(){
    switch(type){
    case 0:{
      return sm->fetch(nLines,chunkSize);
      break;
    }
    case 3:{
      return mytglfs->fetch(nLines);
      break;
    }
    case 4:{
      //      fprintf(stderr,"fetching\n");
      funkyPars *fp = mysims->fetch(chunkSize); 
      //delete [] fp->anc;
      return fp;
      break;
    }
    case 5:{
      funkyPars *fp = bglObj->fetch(nLines,chunkSize); 
      //delete [] fp->anc;
      return fp;
      break;
    }
    default:{
      return pl->fetch(nLines,chunkSize);
      break;
    }
    }
}
